config/routes.rb
Rails.application.routes.draw do

 root :to => 'pages#front'
  
 get 'ui(/:action)', controller: 'ui'
 
 get '/ruby-version' => 'application#ruby_version'

 resources :funds, except: [:destroy]
 resources :patrons, except: [:destroy]
 
 resources :recharges do
   collection do
     get 'search', to: 'recharges#search'
     get 'process_batch', to: 'recharges#process_batch'
     get 'create_output', to: 'recharges#create_output'
     get 'ftp_file', to: 'recharges#ftp_file'
   end 
 end

 resources :invoices do
   collection do
     get 'search', to: 'invoices#search'
     get 'process_batch', to: 'invoices#process_batch'
     get 'create_charge_output', to: 'invoices#create_charge_output'
     get 'create_person_output', to: 'invoices#create_person_output'
     get 'create_entity_output', to: 'invoices#create_entity_output'
     get 'ftp_file', to: 'invoices#ftp_file'
     get 'create_report', to: 'invoices#create_report'
     get 'merge_records', to: 'invoices#merge_records'
   end
 end

 get '/invoices/:id/create_bill', to: 'invoices#create_bill', as: :create_bill_invoice

 get "/signin", to: 'sessions#new', as: :signin
 get "/auth/shibboleth", as: :shibboleth
 get "/auth/developer", to: 'sessions#developer', as: :developer
 match "/auth/shibboleth/callback" => "sessions#shibboleth", as: :callback, via: [:get, :post]
 match "/signout" => "sessions#destroy", as: :signout, via: [:get, :post]
end

app/models/invoice.rb
# encoding: utf-8
#---
# @author hweng@ucsd.edu
#---

class Invoice < ActiveRecord::Base
  belongs_to :patron

  monetize :charge_cents, numericality: {
    greater_than_or_equal_to: 0,
    less_than_or_equal_to: 1_000_000
  }

  validates :invoice_num, presence: true, uniqueness: true
  validates :number_prints, presence: true
  validates :invoice_type, presence: true
  validates :status, presence: true
  validates :comments, presence: true
  validates :patron_id, presence: true

  delegate :name, to: :patron, prefix: :patron
  delegate :email_address, to: :patron, prefix: :patron
  delegate :ar_code, to: :patron, prefix: :patron
  delegate :address1, to: :patron, prefix: :patron
  delegate :address2, to: :patron, prefix: :patron
  delegate :address3, to: :patron, prefix: :patron
  delegate :address4, to: :patron, prefix: :patron
  delegate :city, to: :patron, prefix: :patron
  delegate :state, to: :patron, prefix: :patron
  delegate :zip1, to: :patron, prefix: :patron
  delegate :zip2, to: :patron, prefix: :patron
  delegate :country_code, to: :patron, prefix: :patron
  # delegate :entity_pending_status, to: :patron, prefix: :patron

  START = 50_010

  def self.search_by_patron_name(search_term)
    blank_term(search_term)

    if !Patron.find_by(name: search_term).nil?
      patron_id = Patron.find_by(name: search_term)
      where('patron_id = ? ', patron_id).order('created_at DESC')
    else
      []
    end
  end

  def self.search_by_invoice_num(search_term)
    blank_term(search_term)

    if !find_by('invoice_num = ?', search_term).nil?

      where('invoice_num = ?', search_term)
    else
      []
    end
  end

  def self.blank_term(search_term)
    return [] if search_term.blank?
  end

  def self.search_all_pending_status
    where(status: 'pending').order('created_at DESC')
  end

  def self.pending_status_count
    search_all_pending_status.count
  end

  ##
  # Handles mapping for PERSON ENTITY and CHARGE output files
  #

  def self.person_output
    h_column1_21 = 'PHDR' + ' ' * 1 + 'CLIBRARY.PERSON' + ' ' * 1
    h_column35_320 = ' ' * 1 + '000001' + ' ' * 279

    "#{header_row(h_column1_21, h_column35_320)}#{person_detail_rows}#{trailer_row('PTRL', person_count)}"
  end

  def self.entity_output
    h_column1_21 = 'EHDR' + ' ' * 1 + 'CLIBRARY.ENTITY' + ' ' * 1
    h_column35_320 = ' ' * 1 + '000001' + ' ' * 279

    "#{header_row(h_column1_21, h_column35_320)}#{entity_detail_rows}#{trailer_row('ETRL', entity_count)}"
  end

  def self.charge_output
    h_column1_21 = 'CHDR' + ' ' * 1 + 'CLIBRARY.CHARGE' + ' ' * 1
    h_column35_320 = ' ' * 1 + '000001' + ' ' * 279

    "#{header_row(h_column1_21, h_column35_320)}#{charge_detail_rows}#{charge_trailer_row}"
  end

  def self.header_row(h_column1_21, h_column35_320)
    transaction_date = Time.zone.now.strftime('%m%d%y')
    h_column28 = ' ' * 1

    "#{h_column1_21}#{transaction_date}#{h_column28}#{transaction_date}#{h_column35_320}\n"
  end

  def self.trailer_row(col1, count)
    t_column1_5 = col1 + ' ' * 1
    t_column12_320 = ' ' * 309
    record_count = convert_record_count(count + 2)

    "#{t_column1_5}#{record_count}#{t_column12_320}"
  end

  def self.charge_trailer_row
    t_column1_5 = 'CTRL' + ' ' * 1
    t_column12 = ' '
    t_column24_320 = ' ' * 297
    record_count = convert_record_count(pending_status_count + 2)
    total_amount = convert_invoice_charge(total_charge)

    "#{t_column1_5}#{record_count}#{t_column12}#{total_amount}#{t_column24_320}"
  end

  def self.charge_detail_rows
    result_arr = search_all_pending_status

    d_column1 = 'A'
    d_column11_51 = ' ' * 35 + 'LIBLPS'
    d_column63_68 = ' ' * 6
    d_column79_320 = ' ' * 240

    charge_detail = ''

    result_arr.each_with_index do |invoice, _index|
      charge_amount = convert_invoice_charge(invoice.charge)
      document_num = convert_invoice_num(invoice.invoice_num)
      account_id = process_person_id(invoice)

      charge_detail += "#{d_column1}#{account_id}#{d_column11_51}#{charge_amount}#{d_column63_68}#{document_num}#{d_column79_320}\n"
    end
    charge_detail
  end

  def self.person_detail_rows
    result_arr = search_all_pending_status
    person_detail_rows = ''

    d_column1_10 = 'C' + ' ' * 9
    d_column20_23 = ' ' * 4
    d_column114_119 = ' ' * 6

    result_arr.each_with_index do |invoice, _index|
      unless entity?(invoice.patron_ar_code)
        person_id = process_person_id(invoice)
        name_key = process_name_key(invoice)
        full_name = process_full_name(invoice)

        person_detail_rows += "#{d_column1_10}#{person_id}#{d_column20_23}#{name_key}#{full_name}#{d_column114_119}"
        person_detail_rows += process_address(invoice)
      end
    end
    person_detail_rows
  end

  def self.entity_detail_rows
    result_arr = search_all_pending_status
    d_column1_9 = 'CPUBLPUBL'
    d_column10_18 = ' ' * 9
    d_column118_119 = ' ' * 2
    entity_detail = ''

    result_arr.each_with_index do |invoice, _index|
      if entity?(invoice.patron_ar_code)
        person_id = process_person_id(invoice)
        name_key = process_name_key(invoice)
        full_name = process_full_name(invoice)

        entity_detail += "#{d_column1_9}#{d_column10_18}#{person_id}#{name_key}#{full_name}#{d_column118_119}"
        entity_detail += process_address(invoice)
      end
    end
    entity_detail
  end

  def self.convert_invoice_charge(amount)
    s_amount = (10 * amount).to_f.round.to_s # 0.50 --> "50"
    '0' * (10 - s_amount.length) + s_amount + '{'
  end

  def self.convert_invoice_num(invoice_num)
    invoice_num.to_s.rjust(10, ' ')
  end

  def self.convert_record_count(input)
    input.to_s.rjust(6, '0')
  end

  def self.process_person_id(invoice)
    invoice.patron_ar_code
  end

  def self.process_name_key(invoice)
    input = invoice.patron_name
    input + ' ' * (35 - input.length)
  end

  def self.process_full_name(invoice)
    input = invoice.patron_name
    input + ' ' * (55 - input.length)
  end

  def self.process_address(invoice)
    d_column291_320 = ' ' * 30
    address1 = convert_address(invoice.patron_address1)
    address2 = convert_address(invoice.patron_address2)
    address3 = convert_address(invoice.patron_address3)
    address4 = convert_address(invoice.patron_address4)
    city = convert_city(invoice.patron_city)
    state = invoice.patron_state
    zip1 = invoice.patron_zip1
    zip2 = convert_zip2(invoice.patron_zip2)
    country_code = convert_country(invoice.patron_country_code)

    "#{address1}#{address2}#{address3}#{address4}#{city}#{state}#{zip1}#{zip2}#{country_code}#{d_column291_320}\n"
  end

  def self.convert_address(input)
    convert_format(35, input)
  end

  def self.convert_zip2(input)
    convert_format(4, input)
  end

  def self.convert_country(input)
    convert_format(2, input)
  end

  def self.convert_city(input)
    input + ' ' * (18 - input.length)
  end

  def self.convert_format(num, input)
    input.blank? ? (' ' * num) : (input + ' ' * (num - input.length))
  end

  def self.entity?(input)
    input[0, 2] == 'AA' ? true : false
  end

  def self.entity_count
    result_arr = search_all_pending_status
    count = 0

    result_arr.each do |invoice|
      count += 1 if entity?(invoice.patron_ar_code)
    end
    count
  end

  def self.person_count
    result_arr = search_all_pending_status
    count = 0

    result_arr.each do |invoice|
      count += 1 unless entity?(invoice.patron_ar_code)
    end
    count
  end

  def self.total_charge
    result_arr = search_all_pending_status
    total_charge = 0

    result_arr.each_with_index do |invoice, _index|
      charge = invoice.charge
      total_charge += charge
    end
    total_charge
  end

  ##
  # Handles PERSON ENTITY and CHARGE file creation
  #

  def self.get_path(file_name)
    'tmp/ftp/' + file_name
  end

  def self.create_entity_file
    file_name = Invoice.entity_lfile_name
    path = get_path(file_name)
    content = Invoice.entity_output

    write_file(path, content)

    file_name
  end

  def self.create_person_file
    file_name = Invoice.person_lfile_name
    path = get_path(file_name)
    content = Invoice.person_output

    write_file(path, content)

    file_name
  end

  def self.create_charge_file
    file_name = Invoice.charge_lfile_name
    path = get_path(file_name)
    content = Invoice.charge_output

    write_file(path, content)

    file_name
  end

  def self.write_file(path, content)
    File.open(path, 'w') do |f|
      f.write(content)
    end
  end

  ##
  # Handles file name convention used in ftp and emails.
  #

  def self.entity_lfile_name
    'ENTITY.D' + convert_to_julian_date + '.TXT'
  end

  def self.person_lfile_name
    'PERSON.D' + convert_to_julian_date + '.TXT'
  end

  def self.charge_lfile_name
    'CHARGE.D' + convert_to_julian_date + '.TXT'
  end

  def self.entity_file_name
    'SISP.ARD2501.LIBBUS.ENTITY.D' + convert_to_julian_date
  end

  def self.person_file_name
    'SISP.ARD2501.LIBBUS.PERSON.D' + convert_to_julian_date
  end

  def self.charge_file_name
    'SISP.ARD2501.LIBBUS.CHARGE.D' + convert_to_julian_date
  end

  def self.convert_to_julian_date
    Time.zone.today.strftime('%y') + Time.zone.today.yday.to_s.rjust(3, '0')
  end

  def self.send_file
    tmp_dir = 'tmp/ftp/'
    remote_dir = Rails.application.secrets.sftp_folder + '/'

    local_charge_file_path = tmp_dir + create_charge_file
    remote_charge_file_path = remote_dir + create_charge_file
    local_entity_file_path = tmp_dir + create_entity_file
    remote_entity_file_path = remote_dir + create_entity_file
    local_person_file_path = tmp_dir + create_person_file
    remote_person_file_path = remote_dir + create_person_file

    server_name = Rails.application.secrets.sftp_server_name
    user = Rails.application.secrets.sftp_user
    password = Rails.application.secrets.sftp_password

    Rails.logger.info('Creating SFTP connection')

app/controllers/invoices_controller.rb
# encoding: utf-8
#---
# @author hweng@ucsd.edu
#---

class InvoicesController < ApplicationController
  before_action :require_user
  before_action :set_invoice, only: [:edit, :update, :create_bill]
  before_action :set_patron_list, only: [:new, :create, :edit, :update]
  before_action :set_current_batch, only: [:process_batch, :create_report]

  def index
    @total_count = Invoice.count
    @invoices = all_items(Invoice)
  end

  def new
    @invoice = Invoice.new
  end

  def create
    @invoice = Invoice.new(invoice_params)
    if @invoice.save
      redirect_to new_invoice_path, notice: 'A new invoice is created!'
    else
      render :new
    end
  end

  def edit
    @selected_patron = @invoice.patron_id
    @selected_status = @invoice.status
    @selected_type = @invoice.invoice_type
  end

  def update
    if @invoice.update(invoice_params)
      flash[:notice] = 'Your invoice was updated'
      redirect_to new_invoice_path
    else
      render :edit
    end
  end

  def destroy
    invoice = Invoice.find(params[:id])
    invoice.destroy
    redirect_to invoices_path
  end

  def search
    result_arr = Invoice.search_by_invoice_num(params[:search_term])
    result_arr = Invoice.search_by_patron_name(params[:search_term]) if params[:search_option] == 'patron_name'

    @search_result = result_arr.page(params[:page]) if result_arr.present?
    @search_count = result_arr.count
  end

  def create_report; end

  def process_batch; end

  def create_bill
    respond_to do |format|
      format.html
      format.pdf do
        render pdf: 'invoice',
               template: 'invoices/create_bill.html.haml',
               layout: 'pdf',
               show_as_html: params[:debug].present? # renders html version if you set debug=true in URL
        #:save_to_file => Rails.root.join('pdfs', 'invoice.pdf')
      end
    end
  end

  def create_charge_output
    content = Invoice.charge_output
    render plain: content
  end

  def create_person_output
    content = Invoice.person_output
    render plain: content
  end

  def create_entity_output
    content = Invoice.entity_output
    render plain: content
  end

  def ftp_file
    email_date = convert_date_mmddyy(Time.zone.now)

    Invoice.send_file
    AppMailer.send_invoice_email(current_user, email_date).deliver_now

    flash[:notice] = 'Your CHARGE, ENTITY and PERSON files are uploaded to the campus server, and the email has been sent to ACT.'

    redirect_to invoices_path
  end

  def merge_records
    batch_update_status_field(Invoice)

    flash[:notice] = 'The current batch records have been merged.'
    redirect_to invoices_path
  end

  private

  def invoice_params
    params.require(:invoice).permit(:invoice_num, :number_prints, :comments, :ill_number, :charge, :status, :invoice_type, :patron_id)
  end

  def set_invoice
    @invoice = Invoice.find params[:id]
  end

  def set_patron_list
    @patron_list = Patron.order('name').map { |patron| [patron.name, patron.id] }
  end

  def set_current_batch
    @current_batch_count = Invoice.pending_status_count
    result_arr = Invoice.search_all_pending_status
    @current_batch_result = result_arr.page(params[:page]) if result_arr.present?
  end
end

app/views/invoices/create_bill.html.haml
- if request.format.html?
  %P
    = link_to  url_for(request.params.merge(:format => :pdf)) do
      Download as PDF
%section.ui-invoice
  .container-fluid
    .row
      .col-xs-12
        .invoice-title
          .col-xs-4 
            Library Invoice Number
            = "LB" + @invoice.invoice_num
          .col-xs-4.text-center
            %span.invoice-header Invoice
            %br
              %span.invoice-org UC San Diego Library
          .col-xs-4
            %img.logo.pull-right{:alt => "logo", :src => "https://igpp.ucsd.edu/sites/default/files/images/UCSD-logos-horizontal.png"}/
        .row
          .col-xs-offset-1.col-xs-5
            %address
              %strong 
              = @invoice.patron_ar_code
              %br
              = @invoice.patron_name
              %br
              = @invoice.patron_address1
              %br
              - if !@invoice.patron_address2.blank?
                = @invoice.patron_address2
                %br
              - if !@invoice.patron_address3
                = @invoice.patron_address3
                %br
              - if !@invoice.patron_address4
                = @invoice.patron_address4
                %br
              = @invoice.patron_city
              , 
              = @invoice.patron_state
              = @invoice.patron_zip1 
          .col-xs-offset-1.col-xs-5
            %address
              %strong
              %br
                %br
                  %br
                    %br
                    = convert_date_mmddyy(Time.zone.now)
        .row
          .col-xs-offset-7.col-xs-5
            ILL Phone # 858 534-2528
        %hr
          .row
            .col-xs-6
              %span.small-indent UCSD FEIN: 95-6006144
            .col-xs-offset-1.col-xs-3.col-xs-offset-2
              %table.table.table-condensed
                %thead.thead1
                  %tr
                    %th Detail Code
                    %th Total
                %tbody
                  %tr
                    %td LIBLPS
                    %td
                      = @invoice.charge
    %br
      %br
        / put the macks check payable box here
        .row
          .col-xs-8
            .box
              %font{ :color => "red" } Please call Lilly Chodur in ILL Billing at (858) 534-5902 to pay with a credit card.
              %br
              %br
              Make checks payable to:  The Regents of the University of California
              %br
              Mail payment and a copy of this Invoice to:
              .invoice-address.pull-right
                .invoice-address-inner
                  Central Cashier's Office 0009
                  %br
                    9500 Gilman Drive
                    %br
                      La Jolla, CA 92093-0009
              .box-bottom Please include your account number and the invoice number on your remittance.
        / **************************DESCRIPTION OF CHARGES********************************
        .row
          .col-xs-12.text-center
            .descriptionOfCharges Description of Charges
        %hr.hr-margin
          .row
            .col-xs-2
              %div Invoice #
            .col-xs-2
              ILL Number
            .col-xs-1
              Request(s)
            .col-xs-8
          / **************************TABLE OF CHARGES********************************
          .row
            .col-xs-2
              = "LB" + @invoice.invoice_num
            - if @invoice.ill_number.blank?
              .col-xs-2
                Various
            - else
              .col-xs-2
                = @invoice.ill_number
            .col-xs-1
              = @invoice.number_prints
            .col-xs-5
              Interlibrary Loan
              = @invoice.invoice_type + " -----" 
              = @invoice.number_prints 
              Requests total
              %br/
              = @invoice.comments
            .col-xs-2
              = @invoice.charge
          / **************************TOTAL********************************
          %hr.hr-margin
            .row
              .col-xs-2
              .col-xs-2
              .col-xs-2
              .col-xs-offset-2.col-xs-2
                Total
              .col-xs-2
                $
                = @invoice.charge

app/views/invoices/create_report.html.haml
%section.my_queue.container
  .row
    .col-sm-10.col-sm-offset-1
      %article
        %header
          %h2
            #{@current_batch_count} bills generated from current batch
        %table.table
          %thead
            %tr
              %th(width="15%") Patron Name
              %th(width="15%") Charge
              %th(width="30%") Links
          %tbody
            - if @current_batch_result
              - @current_batch_result.each do |invoice|
                %tr
                  %td
                    = invoice.patron_name
                  %td
                    $
                    = invoice.charge
                  %td
                    = link_to "View and Download Bill", create_bill_invoice_path(invoice.id), method: :get
                  %td
                    %a{:href => "mailto:?subject=Invoice from UCSD Library"} Send an Email
          .pagination-wrapper
            = paginate @current_batch_result if @current_batch_result
           
  
        
         

app/views/invoices/edit.html.haml
%section.create.container
  .row
    .col-sm-8.col-sm-offset-1
      = bootstrap_form_for @invoice do |f|
        = render 'shared/content_title', title: "Edit a Invoice" 
        = render 'shared/error_messages', obj: @invoice
        %fieldset
          = f.hidden_field :invoice_num, value: @invoice.invoice_num
          .required
            = f.select :invoice_type, options_for_select(["Electronic PhotoCopy", "Book Loan"], selected: @selected_type)
          .required
            = f.text_field :number_prints, label: "Number of Prints"
          .required
            = f.text_field :charge, label: "Charge"
          .required
            = f.select :status, options_for_select(["active", "pending"], selected: @selected_status)
          = f.text_field :ill_number, label: "ILL Number"
          .required
            = f.text_area :comments, label: "Comments", rows: 6
          .required
            = f.select :patron_id, options_for_select(@patron_list, selected: @selected_patron), { label: "Patron Name" }
        %fieldset.actions.control-group.col-sm-offset-2
          .controls
            %input(type="submit" value="Save" class="btn btn-primary")
            %input(type="reset" value="Cancel" class="btn btn-default")
            = link_to "Go to index page", recharges_path, method: :get, class: 'btn btn-default'

app/views/invoices/index.html.haml
%section.my_queue.container
  .row
    .col-sm-10.col-sm-offset-1
      %article
        %header
          %h2
            There is total #{@total_count} invoices
        %table.table
          %thead
            %tr
              %th(width="15%") Invoice Number
              %th(width="15%") Invoice type
              %th(width="15%") Charge
              %th(width="15%") Status
              %th(width="15%") Number of Prints
              %th(width="15%") Patron Name
              %th(width="25%") Creation Date
              %th(width="15%") Link
          %tbody
            - if @invoices
              - @invoices.each do |invoice|
                %tr
                  %td
                    = invoice.invoice_num
                  %td
                    = invoice.invoice_type
                  %td
                    $
                    = invoice.charge
                  %td
                    = invoice.status
                  %td
                    = invoice.number_prints
                  %td
                    = invoice.patron_name
                  %td
                    = convert_date_mmddyy(invoice.created_at)
                  %td
                    = link_to create_bill_invoice_path(invoice.id), method: :get do
                      %i.glyphicon.glyphicon-download 
                  %td
                    = link_to edit_invoice_path(invoice.id) do
                      %i.glyphicon.glyphicon-pencil 
          .pagination-wrapper
            = paginate @invoices if @invoices

app/views/invoices/new.html.haml
%section.create.container
  .row
    .col-sm-8.col-sm-offset-1
      = bootstrap_form_for @invoice do |f|
        = render 'shared/content_title', title: "Create a New Invoice" 
        = render 'shared/error_messages', obj: @invoice
        %fieldset
          = f.hidden_field :invoice_num, value: Invoice.count + Invoice::START
          .required
            = f.select :invoice_type, options_for_select(["Electronic PhotoCopy", "Book Loan"], nil)
          .required
            = f.text_field :number_prints, label: "Number of Prints"
          .required
            = f.text_field :charge, label: "Charge"
          .required
            = f.select :status, options_for_select(["active", "pending"], nil)
          = f.text_field :ill_number, label: "ILL Number"
          .required
            = f.text_area :comments, label: "Comments", rows: 6
          .required
            = f.select :patron_id, @patron_list, {include_blank: 'Choose Patron Name'}, { label: "Patron Name" }
        %fieldset.actions.control-group.col-sm-offset-2
          .controls
            %input(type="submit" value="Save" class="btn btn-primary")
            %input(type="reset" value="Cancel" class="btn btn-default")
            = link_to "Go to index page", invoices_path, method: :get, class: 'btn btn-default'

app/views/invoices/process_batch.html.haml
%section.my_queue.container
  .row
    .col-sm-10.col-sm-offset-1
      %article
        %header
          %h2
            Found #{@current_batch_count} invoices for current batch
        %table.table
          %thead
            %tr
              %th(width="15%") Invoice Number
              %th(width="15%") Invoice type
              %th(width="15%") Charge
              %th(width="15%") Status
              %th(width="15%") Number of Prints
              %th(width="15%") Patron Name
              %th(width="25%") Creation Date
              %th(width="15%") Link
          %tbody
            - if @current_batch_result
              - @current_batch_result.each do |invoice|
                %tr
                  %td
                    = invoice.invoice_num
                  %td
                    = invoice.invoice_type
                  %td
                    $
                    = invoice.charge
                  %td
                    = invoice.status
                  %td
                    = invoice.number_prints
                  %td
                    = invoice.patron_name
                  %td
                    = convert_date_mmddyy(invoice.created_at)
                  %td
                    = link_to edit_invoice_path(invoice.id) do
                      %i.glyphicon.glyphicon-pencil
                  %td
                    = link_to invoice, method: :delete, data: { confirm: 'Are you sure you want to delete this?' } do
                      %i.glyphicon.glyphicon-remove
          .pagination-wrapper
            = paginate @current_batch_result if @current_batch_result
        .btn-group.btn-group-justified{:role => "group"}
          .btn-group
            = link_to "Preview Charge Output", create_charge_output_invoices_path, method: :get, class: 'btn btn-default'
          .btn-group{:role => "group"}
            = link_to "Preview Person Output", create_person_output_invoices_path, method: :get, class: 'btn btn-default'
          .btn-group{:role => "group"}
            = link_to "Preview Entity Output", create_entity_output_invoices_path, method: :get, class: 'btn btn-default'
        %br/
        / Button trigger modal
        %button.btn.btn-primary{"data-target" => "#ftp-notes", "data-toggle" => "modal"}
          FTP to ACT
        = render 'shared/modal', target_url: ftp_file_invoices_path, msg_body: "Are you sure you want to upload the current batch to ACT server?"
        = link_to "Create Customer Report", create_report_invoices_path, method: :get, class: 'btn btn-primary'
        %button.btn.btn-primary{"data-target" => "#merge-notes", "data-toggle" => "modal"}
          Merge Records
        = render 'shared/modal_merge', target_url: merge_records_invoices_path, msg_body: "After you click Merge Records, You will not be able to perform the actions of Preview Output, FTP to ACT and Create Customer Report for the current batch records. <br><br>Are you sure you want to merge records?" 
        

app/views/invoices/search.html.haml
%section.my_queue.container
  .row
    .col-sm-10.col-sm-offset-1
      %article
        %header
          %h2
            #{@search_count} invoices found from database.
        = form_tag search_invoices_path, method: "GET", id: "myForm" do
          .input-group.front-input
            %input.form-control.search-input(name="search_term" type="text" placeholder="Search Invoice by Patron Name or #")
            .input-group-btn
              %button.btn.btn-default(type="submit")
                %span.glyphicon.glyphicon-search.right2{"aria-hidden" => "true"}
          .row.text-center.search-options
            .span12.top15
              %span.radio-label
                Search By:
              %label.radio-inline
                %input{:type => "radio", :name => "search_option", :value => "patron_name"}
                  Patron Name
              %label.radio-inline
                %input{:type => "radio", :name => "search_option", :value => "invoice_num"}
                  Invoice Number
      %br 
      - if @search_count > 0  
        %table.table
          %thead
            %tr
              %th(width="15%") Invoice Number
              %th(width="15%") Invoice type
              %th(width="15%") Charge
              %th(width="15%") Status
              %th(width="15%") Number of Prints
              %th(width="15%") Patron Name
              %th(width="25%") Creation Date
              %th(width="15%") Link
          %tbody
            - if @search_result
              - @search_result.each do |invoice|
                %tr
                  %td
                    = invoice.invoice_num
                  %td
                    = invoice.invoice_type
                  %td
                    $
                    = invoice.charge
                  %td
                    = invoice.status
                  %td
                    = invoice.number_prints
                  %td
                    = invoice.patron_name
                  %td
                    = convert_date_mmddyy(invoice.created_at)
                  - if invoice.status != "submitted"
                    %td
                      = link_to edit_invoice_path(invoice.id) do
                        %i.glyphicon.glyphicon-pencil
          .pagination-wrapper
            = paginate @search_result if @search_result